commit 7b1c1fc0e6bc2970c96ae12e9cb23df0b3eadf4a
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Sat Aug 28 20:09:44 2021

    Fortran - reject function entries with mismatched characteristics
    
    gcc/fortran/ChangeLog:
    
            PR fortran/87737
            * resolve.c (resolve_entries): For functions of type CHARACTER
            tighten the checks for matching characteristics.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/87737
            * gfortran.dg/entry_24.f90: New test.
    
    (cherry picked from commit f9809ef57005409ee658294d6e8dad9ee8897e88)

diff --git a/gcc/fortran/resolve.c b/gcc/fortran/resolve.c
index 3e44746da87..48e3eb1853c 100644
--- a/gcc/fortran/resolve.c
+++ b/gcc/fortran/resolve.c
@@ -804,6 +804,15 @@ resolve_entries (gfc_namespace *ns)
 	     the same string length, i.e. both len=*, or both len=4.
 	     Having both len=<variable> is also possible, but difficult to
 	     check at compile time.  */
+	  else if (ts->type == BT_CHARACTER
+		   && (el->sym->result->attr.allocatable
+		       != ns->entries->sym->result->attr.allocatable))
+	    {
+	      gfc_error ("Function %s at %L has entry %s with mismatched "
+			 "characteristics", ns->entries->sym->name,
+			 &ns->entries->sym->declared_at, el->sym->name);
+	      return;
+	    }
 	  else if (ts->type == BT_CHARACTER && ts->u.cl && fts->u.cl
 		   && (((ts->u.cl->length && !fts->u.cl->length)
 			||(!ts->u.cl->length && fts->u.cl->length))
diff --git a/gcc/testsuite/gfortran.dg/entry_24.f90 b/gcc/testsuite/gfortran.dg/entry_24.f90
new file mode 100644
index 00000000000..9773597f4e1
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/entry_24.f90
@@ -0,0 +1,20 @@
+! { dg-do compile }
+! PR fortran/87737 - improve check on function entry characteristics
+
+function f() ! { dg-error "mismatched characteristics" }
+  character(:), allocatable :: f
+  character(1)              :: g
+  f = 'f'
+  return
+entry g()
+  g = 'g'
+end
+
+function f2() ! { dg-error "mismatched characteristics" }
+  character(1)              :: f2
+  character(1), allocatable :: g2
+  f2 = 'f'
+  return
+entry g2()
+  g2 = 'g'
+end

